## scons 4.5.2+dfsg

=== SConstruct ===
#
# SConstruct file to build scons packages during development.
#
# See the README.rst file for an overview of how SCons is built and tested.
import os.path
import sys
import textwrap
from time import strftime

copyright_years = strftime('2001 - %Y')

# This gets inserted into the man pages to reflect the month of release.
month_year = strftime('%B %Y')
#
# MIT License
#
# Copyright The SCons Foundation
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#


project = 'scons'
default_version = '4.5.2'
copyright = "Copyright (c) %s The SCons Foundation" % copyright_years

#
# We let the presence or absence of various utilities determine whether
# or not we bother to build certain pieces of things.  This should allow
# people to still do SCons packaging work even if they don't have all
# of the utilities installed
#
print("git    :%s" % git)
print("gzip   :%s" % gzip)
print("unzip  :%s" % unzip)
print("zip    :%s" % zip_path)

#
# Adding some paths to sys.path, this is mainly needed
# for the doc toolchain.
#
addpaths = [os.path.abspath(os.path.join(os.getcwd(), 'bin')),
            os.path.abspath(os.path.join(os.getcwd(), 'testing/framework'))]
for a in addpaths:
    if a not in sys.path:
        sys.path.append(a)

# Use site_scons logic to process command line arguments
command_line = BuildCommandLine(default_version)
command_line.process_command_line_vars()

Default('.', command_line.build_dir)
# Just make copies, don't symlink them.
SetOption('duplicate', 'copy')

packaging_flavors = [
    ('tar-gz', "The normal .tar.gz file for end-user installation."),
    ('local-tar-gz', "A .tar.gz file for dropping into other software " +
     "for local use."),
    ('zip', "The normal .zip file for end-user installation."),
    ('local-zip', "A .zip file for dropping into other software " +
     "for local use."),
    ('src-tar-gz', "A .tar.gz file containing all the source " +
     "(including tests and documentation)."),
    ('src-zip', "A .zip file containing all the source " +
     "(including tests and documentation)."),
]

test_tar_gz_dir = os.path.join(command_line.build_dir, "test-tar-gz")
test_src_tar_gz_dir = os.path.join(command_line.build_dir, "test-src-tar-gz")
test_local_tar_gz_dir = os.path.join(command_line.build_dir, "test-local-tar-gz")
test_zip_dir = os.path.join(command_line.build_dir, "test-zip")
test_src_zip_dir = os.path.join(command_line.build_dir, "test-src-zip")
test_local_zip_dir = os.path.join(command_line.build_dir, "test-local-zip")

unpack_tar_gz_dir = os.path.join(command_line.build_dir, "unpack-tar-gz")
unpack_zip_dir = os.path.join(command_line.build_dir, "unpack-zip")

if is_windows():
    tar_hflag = ''
#     python_project_subinst_dir = os.path.join("Lib", "site-packages", project)
#     project_script_subinst_dir = 'Scripts'
else:
    tar_hflag = 'h'
#     python_project_subinst_dir = os.path.join("lib", project)
#     project_script_subinst_dir = 'bin'

indent_fmt = '  %-26s  '

Help("""\
The following aliases build packages of various types, and unpack the
contents into build/test-$PACKAGE subdirectories, which can be used by the
runtest.py -p option to run tests against what's been actually packaged:

""")

aliases = sorted(packaging_flavors + [('doc', 'The SCons documentation.')])

for alias, help_text in aliases:
    tw = textwrap.TextWrapper(
        width=78,
        initial_indent=indent_fmt % alias,
        subsequent_indent=indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

Help("""
The following command-line variables can be set:

""")

for variable, help_text in command_line.command_line_variables:
    tw = textwrap.TextWrapper(
        width=78,
        initial_indent=indent_fmt % variable,
        subsequent_indent=indent_fmt % '' + '  ',
    )
    Help(tw.fill(help_text) + '\n')

revaction = SCons_revision
revbuilder = Builder(action=Action(SCons_revision,
                                   varlist=['COPYRIGHT', 'VERSION']))

env = Environment(
    ENV=command_line.ENV,

    BUILD=command_line.build_id,
    BUILDDIR=command_line.build_dir,
    BUILDSYS=command_line.build_system,
    COPYRIGHT_YEARS=copyright_years,
    COPYRIGHT=copyright,
    DATE=command_line.date,
    DEB_DATE=deb_date,

    DEVELOPER=command_line.developer,
    DISTDIR=os.path.join(command_line.build_dir, 'dist'),
    MONTH_YEAR=month_year,
    REVISION=command_line.revision,
    VERSION=command_line.version,

    TAR_HFLAG=tar_hflag,

    ZIP=zip_path,
    ZIPFLAGS='-r',
    UNZIP=unzip,
    UNZIPFLAGS='-o -d $UNPACK_ZIP_DIR',

    # ZCAT=zcat,
    # ZIPID=zipit,

    TEST_SRC_TAR_GZ_DIR=test_src_tar_gz_dir,
    TEST_SRC_ZIP_DIR=test_src_zip_dir,
    TEST_TAR_GZ_DIR=test_tar_gz_dir,
    TEST_ZIP_DIR=test_zip_dir,

    UNPACK_TAR_GZ_DIR=unpack_tar_gz_dir,
    UNPACK_ZIP_DIR=unpack_zip_dir,

    BUILDERS={'SCons_revision': revbuilder,
              'SOElim': soelimbuilder},

    PYTHON='"%s"' % sys.executable,
    PYTHONFLAGS='-tt',
)

Version_values = [Value(command_line.version), Value(command_line.build_id)]

installed_local_files = create_local_packages(env)

update_init_file(env)
#
#
#
#
# Documentation.
#
Export('command_line', 'env', 'whereis', 'revaction')

SConscript('doc/SConscript')


# Copy manpage's into base dir for inclusion in pypi packages
man_pages = env.Install("#/", Glob("#/build/doc/man/*.1"))

# Build packages for pypi
wheel = env.Command('$DISTDIR/SCons-${VERSION}-py3-none-any.whl', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
            '$PYTHON setup.py bdist_wheel')

zip_file = env.Command('$DISTDIR/SCons-${VERSION}.zip', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
            '$PYTHON setup.py sdist --format=zip')
tgz_file = env.Command('$DISTDIR/SCons-${VERSION}.tar.gz', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
            '$PYTHON setup.py sdist --format=gztar')

# Now set depends so the above run in a particular order
env.Depends(tgz_file, [zip_file, wheel])

# NOTE: Commenting this out as the manpages are expected to be in the base directory when manually
# running setup.py from the base of the repo.
# NOTE: This used by distro package maintainers.
# env.AddPostAction(tgz_file, Delete(man_pages))

# TODO add auto copyright date to README.rst, LICENSE
# TODO build API DOCS

=== doc/design/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook'], 
                  toolpath=['../../SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

#
# Create document
#
env.DocbookXInclude('design_xi.xml', 'main.xml')
env.DocbookXslt('design.xml', 'design_xi.xml', 
                xsl='../xslt/to_docbook.xslt')
env.DocbookHtmlChunked('index.html','design.xml', base_dir='scons-design/')
if has_pdf:
    env.DocbookPdf('scons-design.pdf','design.xml')

=== doc/man/SConstruct ===
#
# SConstruct file for building SCons documentation.
#

#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import os

env = Environment(ENV={'PATH' : os.environ['PATH']},
                  tools=['docbook','gs','zip'],
                  toolpath=['../../SCons/Tool'],
                  DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
                  DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl')

has_pdf = False
if (env.WhereIs('fop') or 
    env.WhereIs('xep')):
    has_pdf = True

# Helper function, combining all the steps for a single target
def createManPages(env, target):
    env.DocbookXInclude('%s_xi.xml' % target, '%s.xml' % target)
    env.DocbookXslt('%s_db.xml' % target, '%s_xi.xml' % target, 
                    xsl='../xslt/to_docbook.xslt')
    env.DocbookHtml('scons-%s.html' % target,'%s_db.xml' % target)
    env.DocbookMan('%s.1' % target, '%s_db.xml' % target)
    if has_pdf:
        env.DocbookPdf('scons-%s.pdf' % target,'%s_db.xml' % target)

#
# Create MAN pages
#
createManPages(env, "scons")
createManPages(env, "sconsign")
createManPages(env, "scons-time")

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs('OEBPS/cover.jpg','scons-scons.pdf', 
                 GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q')
    epub = env.DocbookEpub('scons-man.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== test/CacheDir/invalid_custom_cachedir_fixture/SConstruct ===
class CustomCacheDir:
    pass

env = Environment(tools=[])
env.CacheDir('cache', CustomCacheDir)
env.Command('file.out', 'file.in', Copy('$TARGET', '$SOURCE'))

=== test/CompilationDatabase/fixture/SConstruct ===
import sys

DefaultEnvironment(tools=[])
env = Environment(
    PYTHON=sys.executable,
    LINK='$PYTHON mylink.py',
    LINKFLAGS=[],
    CC='$PYTHON mygcc.py cc',
    CXX='$PYTHON mygcc.py c++',
    tools=['gcc', 'g++', 'gnulink'],
)
env.Tool('compilation_db')

env_abs = env.Clone(COMPILATIONDB_USE_ABSPATH=True)
env_abs.CompilationDatabase('compile_commands_clone_abs.json')

# Should be relative paths
env.CompilationDatabase('compile_commands_only_arg.json')
env.CompilationDatabase(target='compile_commands_target.json')

# Should default name compile_commands.json
env.CompilationDatabase()

# Should be absolute paths
env.CompilationDatabase('compile_commands_over_abs.json', COMPILATIONDB_USE_ABSPATH=True)
env.CompilationDatabase(target='compile_commands_target_over_abs.json', COMPILATIONDB_USE_ABSPATH=True)

# Should be relative paths
env.CompilationDatabase('compile_commands_over_rel.json', COMPILATIONDB_USE_ABSPATH=False)

# Try 1/0 for COMPILATIONDB_USE_ABSPATH
env.CompilationDatabase('compile_commands_over_abs_1.json', COMPILATIONDB_USE_ABSPATH=1)
env.CompilationDatabase('compile_commands_over_abs_0.json', COMPILATIONDB_USE_ABSPATH=0)

env.Program('main', 'test_main.c')

=== test/Configure/conftest_source_file/SConstruct ===
DefaultEnvironment(tools=[])
env = Environment()
env.Append(CPPPATH=['.'])
conf1 = Configure(env)
conf1.CheckHeader("header1.h")
conf1.CheckHeader("header3.h")
conf1.Finish()
env.Program('out', 'main.c')

=== test/Java/java_version_image/SConstruct ===

AddOption('--javac_path',
          dest='javac_path',
          action='store',
          default='/usr/bin',
          type='string')

AddOption('--java_version',
          dest='java_version',
          action='store',
          default='1.6',
          type='string')

path=GetOption('javac_path')
if path[0] == "'":
    path = path[1:-1]

version = GetOption('java_version')

env = Environment(tools = ['javac'],
                  JAVAVERSION = version,
                  )


env.AppendENVPath('PATH',path)

# print('PATH:%s'%env['ENV']['PATH'])


env.Java(target = 'class1', source = 'com/sub/foo')
env.Java(target = 'class2', source = 'com/sub/bar')
env.Java(target = 'class3', source = ['src1', 'src2'])
env.Java(target = 'class4', source = ['src4'])
env.Java(target = 'class5', source = ['src5'])
env.Java(target = 'class6', source = ['src6'])

=== test/Libs/bug2903/SConstruct ===
# SConstruct for testing but #2903.
# The test changes the lib name to make sure it rebuilds
# when the name changes, even if the content of the lib is the same.
# Also, the test passes in extra shlinkflags to ensure things rebuild
# when other linker options change, and not when they don't.
# (This doesn't specifically test LIBPATH, but there's a test for
# that already.)
env=Environment()
libname=ARGUMENTS.get('libname', 'foo')
env.Append(SHLINKFLAGS=' $EXTRA_SHLINKFLAGS')
shlinkflags=ARGUMENTS.get('shlinkflags', '')
env.SharedLibrary('myshared', ['main.c'],
                  LIBS=[libname], LIBPATH='.', EXTRA_SHLINKFLAGS=shlinkflags)

=== test/MSVC/MSVC_BATCH-spaces-targetdir/SConstruct ===
import os.path

env=Environment(MSVC_BATCH=True)

td='tar ge tdir'
VariantDir(td,'src')
env.Program(os.path.join(td,'test_program'),
            [os.path.join(td,a) for a in ['a.c','b.c','c.c']])

=== test/MSVC/MSVC_USE_SCRIPT_ARGS-fixture/SConstruct ===
import os

if 'SCONS_CACHE_MSVC_CONFIG' in os.environ:
    del os.environ['SCONS_CACHE_MSVC_CONFIG']

os.environ['SCONS_MSCOMMON_DEBUG']='MSDEBUG_OUTPUT.log'

DefaultEnvironment(tools=[])
env = Environment(tools=['msvc'], MSVC_USE_SCRIPT='fake_script.bat', MSVC_USE_SCRIPT_ARGS=['one','two'])

=== test/MinGW/bug_2799/SConstruct ===
env = Environment(
    tools=['mingw'],
    SHCCCOMSTR='SHCC $TARGET',
    SHLINKCOMSTR='SHLINK $TARGET',
    LDMODULECOMSTR='LDMODULE $TARGET',
    SHOBSUFFIX='.o',
    SHLIBSUFFIX='.so',
    SHLIBPREFIX='lib',
    LDMODULESUFFIX='.so',
)

env.SharedLibrary('testlib', 'shlib.c')

env.LoadableModule('testmodule', 'module.c')

=== test/packaging/sandbox-test/SConstruct ===

from glob import glob

src_files = glob( 'src/*.c' )
include_files = glob( 'src/*.h' )

SharedLibrary( 'foobar', src_files )

env = Environment(tools=['default', 'packaging'])

env.Package( NAME        = 'libfoobar',
             VERSION     = '1.2.3',
             PACKAGETYPE = 'targz',
             source      = src_files + include_files )

env.Package( NAME        = 'libfoobar',
             VERSION     = '1.2.3',
             PACKAGETYPE = 'zip',
             source      = src_files + include_files )

=== debian/changelog ===
scons (4.5.2+dfsg-2) unstable; urgency=medium

  [ Benjamin Drung <benjamin.drung@canonical.com> ]
  * Build-depend on libharfbuzz-dev for PDF generation with fop
    (closes: #1067317).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 01 Jun 2024 13:43:27 +0200

scons (4.5.2+dfsg-1) unstable; urgency=medium

  [ Debian Janitor <janitor@jelmer.uk> ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

  [ Laszlo Boszormenyi (GCS) ]
  * New major upstream release.
  * Update Standards-Version to 4.6.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 09 Oct 2023 00:58:33 +0200

=== debian/control ===
Source: scons
Section: devel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-all (>= 3.5),
 fop,
 libharfbuzz-dev,
 python3-lxml,
 python3-setuptools,
 biber <!nocheck>,
 clang <!nocheck>,
 gdc <!nocheck>,
 python3-psutil <!nocheck>,
 ldc [amd64] <!nocheck>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.scons.org/
Vcs-Git: https://salsa.debian.org/debian/scons.git
Vcs-Browser: https://salsa.debian.org/debian/scons

Package: scons
Architecture: all
Depends:
 ${python3:Depends},
 ${misc:Depends}
Suggests: scons-doc
Description: replacement for make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.

Package: scons-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: scons-doc (<< 4.0.1)
Replaces: scons-doc (<< 4.0.1)
Suggests: scons (>= 4.0)
Description: Documentation for SCons, a replacement for Make
 SCons is a make replacement providing a range of enhanced features such
 as automated dependency generation and built in compilation cache
 support.  SCons rule sets are Python scripts so as well as the features
 it provides itself SCons allows you to use the full power of Python
 to control compilation.
 .
 This package provides the SCons User's guide.

## scons 4.8.1+dfsg

=== SConstruct ===
--- 
+++ 
@@ -1,17 +1,3 @@
-#
-# SConstruct file to build scons packages during development.
-#
-# See the README.rst file for an overview of how SCons is built and tested.
-import os.path
-import sys
-import textwrap
-from time import strftime
-
-copyright_years = strftime('2001 - %Y')
-
-# This gets inserted into the man pages to reflect the month of release.
-month_year = strftime('%B %Y')
-#
 # MIT License
 #
 # Copyright The SCons Foundation
@@ -34,30 +20,42 @@
 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-#
-
-
+
+
+"""SConstruct file to build scons packages during development/release."""
+
+# See the README.rst file for an overview of how SCons is built and tested.
+
+import os.path
+import sys
+import textwrap
+from time import strftime
+
+copyright_years = strftime('2001 - %Y')
+
+# This gets inserted into the man pages to reflect the month of release.
+month_year = strftime('%B %Y')
 project = 'scons'
-default_version = '4.5.2'
-copyright = "Copyright (c) %s The SCons Foundation" % copyright_years
-
-#
+default_version = '4.8.1'
+copyright = f"Copyright (c) {copyright_years} The SCons Foundation"
+
 # We let the presence or absence of various utilities determine whether
 # or not we bother to build certain pieces of things.  This should allow
 # people to still do SCons packaging work even if they don't have all
 # of the utilities installed
-#
-print("git    :%s" % git)
-print("gzip   :%s" % gzip)
-print("unzip  :%s" % unzip)
-print("zip    :%s" % zip_path)
+print(f"git    :{git}")
+print(f"gzip   :{gzip}")
+print(f"unzip  :{unzip}")
+print(f"zip    :{zip_path}")
 
 #
 # Adding some paths to sys.path, this is mainly needed
 # for the doc toolchain.
 #
-addpaths = [os.path.abspath(os.path.join(os.getcwd(), 'bin')),
-            os.path.abspath(os.path.join(os.getcwd(), 'testing/framework'))]
+addpaths = [
+    os.path.abspath(os.path.join(os.getcwd(), 'bin')),
+    os.path.abspath(os.path.join(os.getcwd(), 'testing/framework')),
+]
 for a in addpaths:
     if a not in sys.path:
         sys.path.append(a)
@@ -71,16 +69,37 @@
 SetOption('duplicate', 'copy')
 
 packaging_flavors = [
-    ('tar-gz', "The normal .tar.gz file for end-user installation."),
-    ('local-tar-gz', "A .tar.gz file for dropping into other software " +
-     "for local use."),
-    ('zip', "The normal .zip file for end-user installation."),
-    ('local-zip', "A .zip file for dropping into other software " +
-     "for local use."),
-    ('src-tar-gz', "A .tar.gz file containing all the source " +
-     "(including tests and documentation)."),
-    ('src-zip', "A .zip file containing all the source " +
-     "(including tests and documentation)."),
+    (
+        'wheel',
+        "The Python wheel file for pip installations."
+    ),
+    (
+        'tar-gz',
+        "The normal .tar.gz file for end-user installation."
+    ),
+    (
+        'local-tar-gz',
+        "A .tar.gz file for dropping into other software for local use.",
+    ),
+    (
+        'zip',
+        "The normal .zip file for end-user installation."),
+    (
+        'local-zip',
+        "A .zip file for dropping into other software for local use."
+    ),
+    (
+        'src-tar-gz',
+        "A .tar.gz file containing all the source (including tests and documentation).",
+    ),
+    (
+        'src-zip',
+        "A .zip file containing all the source (including tests and documentation).",
+    ),
+    (
+        'local-zipapp',
+        "A .pyz local zipapp. Like local-zip without need to unpack.",
+    )
 ]
 
 test_tar_gz_dir = os.path.join(command_line.build_dir, "test-tar-gz")
@@ -102,7 +121,7 @@
 #     python_project_subinst_dir = os.path.join("lib", project)
 #     project_script_subinst_dir = 'bin'
 
-indent_fmt = '  %-26s  '
+indent_fmt = '  %-14s  '
 
 Help("""\
 The following aliases build packages of various types, and unpack the
@@ -135,12 +154,10 @@
     Help(tw.fill(help_text) + '\n')
 
 revaction = SCons_revision
-revbuilder = Builder(action=Action(SCons_revision,
-                                   varlist=['COPYRIGHT', 'VERSION']))
+revbuilder = Builder(action=Action(SCons_revision, varlist=['COPYRIGHT', 'VERSION']))
 
 env = Environment(
     ENV=command_line.ENV,
-
     BUILD=command_line.build_id,
     BUILDDIR=command_line.build_dir,
     BUILDSYS=command_line.build_system,
@@ -148,68 +165,65 @@
     COPYRIGHT=copyright,
     DATE=command_line.date,
     DEB_DATE=deb_date,
-
     DEVELOPER=command_line.developer,
     DISTDIR=os.path.join(command_line.build_dir, 'dist'),
     MONTH_YEAR=month_year,
     REVISION=command_line.revision,
     VERSION=command_line.version,
-
     TAR_HFLAG=tar_hflag,
-
     ZIP=zip_path,
     ZIPFLAGS='-r',
     UNZIP=unzip,
     UNZIPFLAGS='-o -d $UNPACK_ZIP_DIR',
-
     # ZCAT=zcat,
     # ZIPID=zipit,
-
     TEST_SRC_TAR_GZ_DIR=test_src_tar_gz_dir,
     TEST_SRC_ZIP_DIR=test_src_zip_dir,
     TEST_TAR_GZ_DIR=test_tar_gz_dir,
     TEST_ZIP_DIR=test_zip_dir,
-
     UNPACK_TAR_GZ_DIR=unpack_tar_gz_dir,
     UNPACK_ZIP_DIR=unpack_zip_dir,
-
-    BUILDERS={'SCons_revision': revbuilder,
-              'SOElim': soelimbuilder},
-
-    PYTHON='"%s"' % sys.executable,
+    BUILDERS={'SCons_revision': revbuilder, 'SOElim': soelimbuilder},
+    PYTHON=f'"{sys.executable}"',
     PYTHONFLAGS='-tt',
 )
 
 Version_values = [Value(command_line.version), Value(command_line.build_id)]
-
 installed_local_files = create_local_packages(env)
-
 update_init_file(env)
-#
-#
-#
-#
-# Documentation.
-#
+
+# Documentation
 Export('command_line', 'env', 'whereis', 'revaction')
-
 SConscript('doc/SConscript')
 
-
-# Copy manpage's into base dir for inclusion in pypi packages
+# Copy manpages into base dir for inclusion in pypi packages
 man_pages = env.Install("#/", Glob("#/build/doc/man/*.1"))
 
-# Build packages for pypi
-wheel = env.Command('$DISTDIR/SCons-${VERSION}-py3-none-any.whl', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
-            '$PYTHON setup.py bdist_wheel')
-
-zip_file = env.Command('$DISTDIR/SCons-${VERSION}.zip', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
-            '$PYTHON setup.py sdist --format=zip')
-tgz_file = env.Command('$DISTDIR/SCons-${VERSION}.tar.gz', ['setup.cfg', 'setup.py', 'SCons/__init__.py']+man_pages,
-            '$PYTHON setup.py sdist --format=gztar')
+# Build packages for pypi. 'build' makes sdist (tgz) + whl
+wheel = env.Command(
+    target=[
+        '$DISTDIR/SCons-${VERSION}-py3-none-any.whl',
+        '$DISTDIR/SCons-${VERSION}.tar.gz',
+    ],
+    source=['pyproject.toml', 'setup.py', 'SCons/__init__.py'] + man_pages,
+    action='$PYTHON -m build --outdir $DISTDIR',
+)
+env.Alias("wheel", wheel[0])
+env.Alias("tar-gz", wheel[1])
+
+# TODO: this is built the old way, because "build" doesn't make zipfiles,
+# and it deletes its isolated env so we can't just zip that one up.
+zip_file = env.Command(
+    target='$DISTDIR/SCons-${VERSION}.zip',
+    source=['pyproject.toml', 'setup.py', 'SCons/__init__.py'] + man_pages,
+    action='$PYTHON setup.py sdist --format=zip',
+)
+env.Alias("zip", zip_file)
 
 # Now set depends so the above run in a particular order
-env.Depends(tgz_file, [zip_file, wheel])
+# NOTE: 'build' with default options builds sdist, then whl from sdist,
+# so it's already ordered.
+# env.Depends(tgz_file, [zip_file, wheel])
 
 # NOTE: Commenting this out as the manpages are expected to be in the base directory when manually
 # running setup.py from the base of the repo.

=== requirements.txt ===
# No dependencies for running SCons

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = SCons
SOURCEDIR     = sphinx
BUILDDIR      = ../build/doc/api
DOCTREES      = ../build/doc/api

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)"  "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile


# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	$(SPHINXBUILD) -M $@ -d "$(DOCTREES)" "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)



# For macports need
# sudo port install texlive-latex-recommended texlive-fonts-recommended texlive-latex-extra

=== doc/man/SConstruct ===
# SPDX-FileCopyrightText: Copyright The SCons Foundation (https://scons.org)
# SPDX-License-Identifier: MIT

"""
SConstruct file for building SCons manpages.

This is usually invoked as a separate build by the top-level SCons build.

If invoked directly, can add SKIP_PDF=1 to avoid pdf and epub generation.
"""

import os

env = Environment(
    ENV={'PATH': os.environ['PATH']},
    tools=['docbook', 'gs', 'zip'],
    toolpath=['../../SCons/Tool'],
    DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
    DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl',
)

skip_pdf = ARGUMENTS.get('SKIP_PDF', False)
has_pdf = False
if not skip_pdf and any((env.WhereIs('fop'), env.WhereIs('xep'))):
    has_pdf = True

# Helper function, combining all the steps for a single target
def createManPages(env, target):
    env.DocbookXInclude('%s_xi.xml' % target, '%s.xml' % target)
    env.DocbookXslt(
        '%s_db.xml' % target, '%s_xi.xml' % target, xsl='../xslt/to_docbook.xslt'
    )
    env.DocbookHtml('scons-%s.html' % target, '%s_db.xml' % target)
    env.DocbookMan('%s.1' % target, '%s_db.xml' % target)
    if has_pdf:
        env.DocbookPdf('scons-%s.pdf' % target, '%s_db.xml' % target)


#
# Create MAN pages
#
createManPages(env, "scons")
createManPages(env, "sconsign")
createManPages(env, "scons-time")

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs(
        'OEBPS/cover.jpg',
        'scons-scons.pdf',
        GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q',
    )
    epub = env.DocbookEpub('scons-man.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== doc/user/SConstruct ===
# SPDX-FileCopyrightText: Copyright The SCons Foundation (https://scons.org)
# SPDX-License-Identifier: MIT

"""
SConstruct file for building SCons User Guide..

This is usually invoked as a separate build by the top-level SCons build.

If invoked directly, can add SKIP_PDF=1 to avoid pdf and epub generation.
"""

import os

env = Environment(
    ENV={'PATH': os.environ['PATH']},
    tools=['docbook', 'gs', 'zip'],
    toolpath=['../../SCons/Tool'],
    # DOCBOOK_XSLTPROCFLAGS="--stringparam  fop.extensions  1",
    DOCBOOK_DEFAULT_XSL_HTML='html.xsl',
    DOCBOOK_DEFAULT_XSL_HTMLCHUNKED='chtml.xsl',
    DOCBOOK_DEFAULT_XSL_PDF='pdf.xsl',
)

skip_pdf = ARGUMENTS.get('SKIP_PDF', False)
has_pdf = False
if not skip_pdf and any((env.WhereIs('fop'), env.WhereIs('xep'))):
    has_pdf = True

#
# UserGuide for SCons
#
env.DocbookXInclude('scons_xi.xml', 'main.xml')
env.DocbookXslt('scons_ex.xml', 'scons_xi.xml', xsl='../xslt/xinclude_examples.xslt')
env.DocbookXInclude('scons_exi.xml', 'scons_ex.xml')
env.DocbookXslt('scons_db.xml', 'scons_exi.xml', xsl='../xslt/to_docbook.xslt')
env.DocbookHtml('index.html', 'scons_db.xml')
env.DocbookHtmlChunked('index.html', 'scons_db.xml', base_dir='scons-user/')
if has_pdf:
    env.DocbookPdf('scons-user.pdf', 'scons_db.xml')

has_gs = False
if env.WhereIs('gs'):
    has_gs = True

#
# Create the EPUB format
#
if has_gs and has_pdf:
    jpg = env.Gs(
        'OEBPS/cover.jpg',
        'scons-user.pdf',
        GSFLAGS='-dNOPAUSE -dBATCH -sDEVICE=jpeg -dFirstPage=1 -dLastPage=1 -dJPEGQ=100 -r72x72 -q',
    )
    epub = env.DocbookEpub('scons-user.epub', 'scons_db.xml', xsl='epub.xsl')
    env.Depends(epub, jpg)

=== timings/CPPPATH/SConstruct ===
#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

dir_count = int(ARGUMENTS['DIR_COUNT'])

inc_list = [ Dir('inc_%04d' % t) for t in range(dir_count) ]
inc_list.append(Dir('include'))

env = Environment(CPPPATH = inc_list)

env.Object( 'foo.c' )

=== timings/JTimer/SConstruct ===
#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

target_count = int(ARGUMENTS['TARGET_COUNT'])

env = Environment()

def write_file( env, target, source ):
    path_target = env.File( target )[0].path
    outfile = open( path_target, 'w' )
    outfile.write( 'junk' )
    outfile.close()

list = []
for i in range( target_count ):
    target = 'target_%03d' % i
    env.Command( target, [], write_file )
    env.Depends( target, list )
    list.append( target )

=== timings/Java/SConstruct ===
#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

env = Environment()
env.Java('classes', 'src')

=== timings/hundred/SConstruct ===
#
# __COPYRIGHT__
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

target_count = int(ARGUMENTS['TARGET_COUNT'])

def copy_files( env, target, source ):
    for t, s in zip(target, source):
        open(str(t),  'wb').write(open(str(s), 'rb').read())

source_list = ['source_%04d' % t for t in range(target_count)]
target_list = ['target_%04d' % t for t in range(target_count)]

env = Environment()

env.Command( target_list, source_list, copy_files )

=== test/Actions/unicode-signature-fixture/SConstruct ===
# SPDX-License-Identifier: MIT
#
# Copyright The SCons Foundation

fnode = File(u'foo.txt')

def funcact(target, source, env):
    with open(str(target[0]), 'wb') as f:
        f.write(b"funcact\n")
    for i in range(300):
        pass
    return 0

DefaultEnvironment(tools=[])
env = Environment()
env.Command(fnode, [], ["echo $TARGET", funcact])

=== test/CacheDir/custom_cachedir_fixture/SConstruct ===
# SPDX-License-Identifier: MIT
#
# Copyright The SCons Foundation

import SCons

class CustomCacheDir(SCons.CacheDir.CacheDir):
    @classmethod
    def copy_to_cache(cls, env, src, dst):
        print("MY_CUSTOM_CACHEDIR_CLASS")
        super().copy_to_cache(env, src, dst)

DefaultEnvironment(tools=[])
env = Environment(tools=[])
env.CacheDir('cache', CustomCacheDir)
env.Command('file.out', 'file.in', Copy('$TARGET', '$SOURCE'))

=== test/CacheDir/invalid_custom_cachedir_fixture/SConstruct ===
# SPDX-License-Identifier: MIT
#
# Copyright The SCons Foundation

class CustomCacheDir:
    pass

DefaultEnvironment(tools=[])
env = Environment(tools=[])
env.CacheDir('cache', CustomCacheDir)
env.Command('file.out', 'file.in', Copy('$TARGET', '$SOURCE'))

=== debian/changelog ===
scons (4.8.1+dfsg-1) unstable; urgency=medium

  * New major upstream release:
    - no longer uses python3-pkg-resources (closes: #1083765).
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 05 Oct 2024 13:02:20 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  gdc <!nocheck>,
  python3-psutil <!nocheck>,
  ldc [amd64] <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.scons.org/
 Vcs-Git: https://salsa.debian.org/debian/scons.git
